#ifndef NDOMINATEDNAIVE_H_
#define NDOMINATEDNAIVE_H_

#include "VectorSet.h"

/**
 * Class that found the non-dominated set from a given a set of
 * solutions using the algorithm developed by Kung, Luccio and Preparata.
 */
class NonDominance {
public:
	void kungNDominatedSet(vector<double> vSet[], int size, VectorSet &nDom);
	bool dominates(int first, vector<double> x, vector<double> y);	
private:	
	void minimalSet(vector<double> v[], VectorSet &min, int first, int last);	
	void unionM(VectorSet &rSet, VectorSet sSet);
	void minimalSet2D(vector<double> v[], VectorSet &min, int last);	
	void myQuickSort(vector<double> A[], int p, int r);	
	int partition(vector<double> A[], int p, int r);
	int breakTie(vector<double> &a, vector<double> &b);	
};

#endif /*NDOMINATEDNAIVE_H_*/
